//+------------------------------------------------------------------+
//|                                                   TrenderNew.mq4 |
//|                               Copyright  2010, Nikolaj Ostapujk |
//|                                                  nikost@inbox.lv |
//+------------------------------------------------------------------+
//---- indicator settings
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 RoyalBlue
#property indicator_color2 Orange
#property indicator_width1 2
#property indicator_width2 2

//---- indicator parameters
extern int period =5;
extern int delta  = 250;
extern int shift  = 0;
extern int Signal_delta=5;
extern bool Signal_Blue=true;
datetime LastTime;

//---- indicator buffers
double UpBuffer[];
double DnBuffer[];
double smax[];
double smin[];
double trend[];
#define SIGNAL_BAR 1
//----
int ExtCountedBars=0;

//---- Beep()
void Beep(double Level)
  { 
    if (Bid<=Level+Signal_delta*Point && Bid>=Level-Signal_delta*Point  && LastTime!=Time[0])
    {
      PlaySound("news.wav");            
      LastTime = Time[0];        
    }      
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init() {
   int draw_begin;
   string short_name;
   //---- drawing settings
   IndicatorBuffers(5);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);

   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   if(period<2) period=14;
   draw_begin=period-1;
   
   //---- indicator short name
   IndicatorShortName("Env("+period+")");
   SetIndexLabel(0,"UpTrendEnv");
   SetIndexLabel(1,"DnTrendEnv");
   SetIndexDrawBegin(0,draw_begin);
   SetIndexDrawBegin(1,draw_begin);
   //---- indicator buffers mapping
   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,DnBuffer);
   SetIndexBuffer(2,smax);
   SetIndexBuffer(3,smin);
   SetIndexBuffer(4,trend);
   //---- initialization done
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function |
//+------------------------------------------------------------------+
int start() {
   int limit, max, min;
   bool fmax, fmin;
   if(Bars<=period) return(0);
   ExtCountedBars=IndicatorCounted();
   //---- check for possible errors
   if (ExtCountedBars<0) return(-1);
   //---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
   limit=Bars-ExtCountedBars;
   //---- EnvelopesM counted in the buffers
   for(int i=limit; i>=0; i--){
    //  max=iHighest(NULL,0,MODE_HIGH,period,i);
   //   min=iLowest(NULL,0,MODE_LOW,period,i);
      fmax=iFractals(NULL,0,MODE_UPPER,i+shift);
      fmin=iFractals(NULL,0,MODE_LOWER,i+shift);
      smax[i]=High[i]+100*Point;
      smin[i]=Low[i]-100*Point;
      trend[i]=trend[i+1];
      if (fmin) { max=iHighest(NULL,0,MODE_HIGH,period,i); trend[i]=1; }
      if (fmax) { min=iLowest(NULL,0,MODE_LOW,period,i); trend[i]=-1; }
      if (High[max]-Low[min]>delta*Point)
      {
      if(trend[i]>0){
         if (smin[i]<smin[i+1]) smin[i]=smin[i+1];
         UpBuffer[i]=smin[i];
            if (trend[i+1]<0) 
         DnBuffer[i]=EMPTY_VALUE;
      } else {
         if(smax[i]>smax[i+1]) smax[i]=smax[i+1];
         DnBuffer[i]=smax[i];
            if (trend[i+1]>0) 
         UpBuffer[i]=EMPTY_VALUE;
      }
     }
   }
    
     if (Signal_Blue==true)Beep( DnBuffer[0]);
       else Beep( UpBuffer[0]);
   return(0);
   
}

